Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
Algorithm Class Reference

Interface for all crypto algorithms. More...

Inheritance diagram for Algorithm:

## Public Member Functions
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

Interface for all crypto algorithms.

Definition at line 598 of file cryptlib.h.

## Constructor & Destructor Documentation

## ◆ Algorithm()

Algorithm::Algorithm | ( | bool | checkSelfTestStatus = `true` | ) |

Interface for all crypto algorithms.

Parameters

  checkSelfTestStatus | determines whether the object can proceed if the self tests have not been run or failed.

When FIPS 140-2 compliance is enabled and checkSelfTestStatus == true, this constructor throws SelfTestFailure if the self test hasn't been run or fails.

FIPS 140-2 compliance is disabled by default. It is only used by certain versions of the library when the library is built as a DLL on Windows. Also see CRYPTOPP_ENABLE_COMPLIANCE_WITH_FIPS_140_2 in config.h.

Definition at line 46 of file cryptlib.cpp.

## Member Function Documentation

## ◆ AlgorithmName()

virtual std::string Algorithm::AlgorithmName | ( |  | ) | const
| inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like `AES` or `AES/GCM`. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet.

Reimplemented in KeyDerivationFunction, AuthenticatedSymmetricCipher, SignatureVerificationFilter, SignerFilter, AuthenticatedDecryptionFilter, HashVerificationFilter, HashFilter, StreamTransformationFilter, BitBucket, CipherModeFinalTemplate_ExternalCipher< ConcretePolicyHolder< Empty, AdditiveCipherTemplate< AbstractPolicyHolder< AdditiveCipherAbstractPolicy, CTR_ModePolicy > > > >, BLAKE2b, ClassNullRNG, PKCS12_PBKDF< T >, BLAKE2s, XChaCha20Poly1305_Base, PKCS5_PBKDF2_HMAC< T >, DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >, DH_Domain< DL_GroupParameters_GFP_DefaultSafePrime >, Keccak_Final< T_DigestSize >, Keccak_Final< 64 >, Keccak_Final< 32 >, Keccak_Final< 48 >, Keccak_Final< 28 >, SHAKE_Final< T_Strength >, SHAKE_Final< 128 >, SHAKE_Final< 256 >, SHA3_Final< T_DigestSize >, SHA3_Final< 64 >, SHA3_Final< 32 >, SHA3_Final< 48 >, SHA3_Final< 28 >, HMAC< T >, HMAC< HASH >, HMAC< H >, CRC32C, XTS_ModeBase, AlgorithmImpl< IteratedHash< word32, LittleEndian, T_BlockSize >, RIPEMD160 >, AlgorithmImpl< SimpleKeyingInterfaceImpl< ConcretePolicyHolder< XChaCha20_Policy, AdditiveCipherTemplate<> >, XChaCha20_Info >, XChaCha20_Info >, AlgorithmImpl< SimpleKeyingInterfaceImpl< TTMAC_Base, TTMAC_Base >, TTMAC_Base >, AlgorithmImpl< IteratedHash< word64, BigEndian, T_BlockSize >, SHA384 >, AlgorithmImpl< IteratedHash< word32, BigEndian, T_BlockSize >, SHA224 >, AlgorithmImpl< SimpleKeyingInterfaceImpl< Poly1305TLS_Base, Poly1305TLS_Base >, Poly1305TLS_Base >, AlgorithmImpl< DL_DecryptorBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS::AlgorithmInfo >, AlgorithmImpl< IteratedHash< word32, LittleEndian, T_BlockSize >, RIPEMD128 >, AlgorithmImpl< TF_EncryptorBase, SCHEME_OPTIONS::AlgorithmInfo >, AlgorithmImpl< SimpleKeyingInterfaceImpl< CMAC_Base, CMAC< T > >, CMAC< T > >, AlgorithmImpl< DL_EncryptorBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS::AlgorithmInfo >, AlgorithmImpl< IteratedHash< word32, LittleEndian, T_BlockSize >, RIPEMD256 >, AlgorithmImpl< IteratedHash< word32, BigEndian, T_BlockSize >, SM3 >, AlgorithmImpl< IteratedHash< word64, BigEndian, T_BlockSize >, SHA512 >, AlgorithmImpl< SimpleKeyingInterfaceImpl< HMAC_Base, HMAC< HASH > >, HMAC< HASH > >, AlgorithmImpl< SimpleKeyingInterfaceImpl< CMAC_Base, CMAC< T_BlockCipher > >, CMAC< T_BlockCipher > >, AlgorithmImpl< IteratedHash< word32, NativeByteOrder, 32 >, PanamaHash< B > >, AlgorithmImpl< DL_VerifierBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS::AlgorithmInfo >, AlgorithmImpl< IteratedHash< word32, BigEndian, T_BlockSize >, SHA1 >, AlgorithmImpl< SimpleKeyingInterfaceImpl< HMAC_Base, HMAC< H > >, HMAC< H > >, AlgorithmImpl< SimpleKeyingInterfaceImpl< Poly1305_Base< T >, Poly1305_Base< T > >, Poly1305_Base< T > >, AlgorithmImpl< SimpleKeyingInterfaceImpl< HMAC_Base, HMAC< T > >, HMAC< T > >, AlgorithmImpl< DL_SignerBase< SCHEME_OPTIONS::Element >, SCHEME_OPTIONS::AlgorithmInfo >, AlgorithmImpl< TF_VerifierBase, SCHEME_OPTIONS::AlgorithmInfo >, AlgorithmImpl< SimpleKeyingInterfaceImpl< DMAC_Base< T >, DMAC_Base< T > >, DMAC_Base< T > >, AlgorithmImpl< IteratedHash< word64, LittleEndian, T_BlockSize >, Tiger >, AlgorithmImpl< IteratedHash< T_HashWordType, T_Endianness, T_BlockSize >, T_Transform >, AlgorithmImpl< IteratedHash< word32, BigEndian, T_BlockSize >, SHA256 >, AlgorithmImpl< IteratedHash< word32, LittleEndian, T_BlockSize >, MD4 >, AlgorithmImpl< SimpleKeyingInterfaceImpl< ConcretePolicyHolder< ChaChaTLS_Policy, AdditiveCipherTemplate<> >, ChaChaTLS_Info >, ChaChaTLS_Info >, AlgorithmImpl< IteratedHash< word32, LittleEndian, T_BlockSize >, MD5 >, AlgorithmImpl< SimpleKeyingInterfaceImpl< BlockCipher, BTEA_Info >, BTEA_Info >, AlgorithmImpl< IteratedHash< word32, LittleEndian, T_BlockSize >, RIPEMD320 >, AlgorithmImpl< IteratedHash< word64, BigEndian, T_BlockSize >, Whirlpool >, AlgorithmImpl< SimpleKeyingInterfaceImpl< CBC_MAC_Base, CBC_MAC< T > >, CBC_MAC< T > >, AlgorithmImpl< TF_SignerBase, SCHEME_OPTIONS::AlgorithmInfo >, AlgorithmImpl< TF_DecryptorBase, SCHEME_OPTIONS::AlgorithmInfo >, Scrypt, PKCS5_PBKDF1< T >, ChaCha20Poly1305_Base, HKDF< T >, GCM_Base, CRC32, VMAC_Base, CCM_Base, Adler32, and EAX_Base.

Definition at line 619 of file cryptlib.h.

## ◆ AlgorithmProvider()

virtual std::string Algorithm::AlgorithmProvider | ( |  | ) | const
| inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented in BLAKE2b, AdditiveCipherTemplate< BASE >, AdditiveCipherTemplate<>, AdditiveCipherTemplate< AbstractPolicyHolder< AdditiveCipherAbstractPolicy, CTR_ModePolicy > >, HMAC_DRBG< HASH, STRENGTH, SEEDLENGTH >, BLAKE2s, Hash_DRBG< HASH, STRENGTH, SEEDLENGTH >, AutoSeededX917RNG< BLOCK_CIPHER >, SHA384, XChaCha20Poly1305_Base, SHA512, RDSEED, SHA224, PadlockRNG, IteratedHashBase< word32, HashTransformation >, IteratedHashBase< T_HashWordType, HashTransformation >, IteratedHashBase< word32, MessageAuthenticationCode >, IteratedHashBase< word64, HashTransformation >, IteratedHashBase< word64, MessageAuthenticationCode >, SHA256, DARN, RDRAND, EAX_Final< T_BlockCipher, T_IsEncryption >, HMAC< T >, HMAC< HASH >, HMAC< H >, Poly1305_Base< T >, CRC32C, XTS_ModeBase, CipherModeBase, SHA1, Weak::PanamaHash< B >, ChaCha20Poly1305_Base, CRC32, Tiger, GCM_Base, CMAC_Base, Whirlpool, DMAC_Base< T >, VMAC_Base, CCM_Base, and EAX_Base.

Definition at line 636 of file cryptlib.h.

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp